# core/plugs/stop.py
#
#

""" regen, regen. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import get_uptime, get_clsname
from core import kernel

## CMNDS

def stop(event):
    global kernel
    rest = event.get_rest()
    if not rest: return
    target = rest.upper()
    todo = []
    for item in kernel.services:
        if target.upper() in item.upper():
            kernel.services[target].stop()
            todo.append(target)
    for item in todo: del kernel.services[item]
    todo = []
    for core in kernel.fleet:
        if target in str(core): core.stop() ; todo.append(core)
    for item in todo: kernel.fleet.remove(item)
    event.ok()

kernel.cmnds.register("stop", stop)

def start(event):
    rest = event.get_rest()
    if not rest: return
    event = kernel.plugs.init(rest)
    if event: event.wait() ; event.ok()
    
kernel.cmnds.register("start", start)

def status(event):
    global kernel
    for bot in kernel.fleet:
        status = bot._status
        event.reply("%s: %s" % (bot.what, status.status))
    for thing in kernel.services.values():
        if not thing: continue
        status = thing._status
        event.reply("%s: %s" % (thing.what, status.status))
    for runner in kernel.workers._runners:
        status = runner._status
        event.reply("%s: %s" % (get_clsname(runner), status.status))
    for runner in kernel.cmnds._runners:
        status = runner._status
        event.reply("%s: %s" % (get_clsname(runner), status.status))

kernel.cmnds.register("status", status)

def uptime(event):
    global kernel
    for bot in kernel.fleet:
        txt = get_uptime(bot)
        event.reply("%s: %s" % (get_clsname(bot), txt))
    for thing in kernel.services.values():
        if not thing: continue
        txt = get_uptime(thing)
        event.reply("%s: %s" % (get_clsname(thing), txt))
    for runner in kernel.workers._runners:
        txt = get_uptime(runner)
        event.reply("%s: %s" % (runner.name, txt))
    for runner in kernel.cmnds._runners:
        txt = get_uptime(runner)
        event.reply("%s: %s" % (runner.name, txt))

kernel.cmnds.register("uptime", uptime)
